// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// RoleListRequest role list request
//
// swagger:model roleListRequest
type RoleListRequest struct {

	// limit
	Limit int64 `json:"limit,omitempty"`

	// names
	Names []string `json:"names"`

	// order
	// Enum: [-1 0 1]
	Order int64 `json:"order,omitempty"`

	// skip
	Skip int64 `json:"skip,omitempty"`

	// sort
	// Enum: [id name]
	Sort string `json:"sort,omitempty"`
}

// Validate validates this role list request
func (m *RoleListRequest) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateOrder(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSort(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var roleListRequestTypeOrderPropEnum []interface{}

func init() {
	var res []int64
	if err := json.Unmarshal([]byte(`[-1,0,1]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		roleListRequestTypeOrderPropEnum = append(roleListRequestTypeOrderPropEnum, v)
	}
}

// prop value enum
func (m *RoleListRequest) validateOrderEnum(path, location string, value int64) error {
	if err := validate.EnumCase(path, location, value, roleListRequestTypeOrderPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *RoleListRequest) validateOrder(formats strfmt.Registry) error {

	if swag.IsZero(m.Order) { // not required
		return nil
	}

	// value enum
	if err := m.validateOrderEnum("order", "body", m.Order); err != nil {
		return err
	}

	return nil
}

var roleListRequestTypeSortPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["id","name"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		roleListRequestTypeSortPropEnum = append(roleListRequestTypeSortPropEnum, v)
	}
}

const (

	// RoleListRequestSortID captures enum value "id"
	RoleListRequestSortID string = "id"

	// RoleListRequestSortName captures enum value "name"
	RoleListRequestSortName string = "name"
)

// prop value enum
func (m *RoleListRequest) validateSortEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, roleListRequestTypeSortPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *RoleListRequest) validateSort(formats strfmt.Registry) error {

	if swag.IsZero(m.Sort) { // not required
		return nil
	}

	// value enum
	if err := m.validateSortEnum("sort", "body", m.Sort); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *RoleListRequest) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *RoleListRequest) UnmarshalBinary(b []byte) error {
	var res RoleListRequest
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
